#!/usr/bin/perl -T -w
# $Header: /var/lib/cvsd/var/lib/cvsd/Fuzzled/src/Drivers/http.pl,v 1.1.1.1 2007-02-14 12:20:29 timb Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# (c) Tim Brown, 2006
# <mailto:timb@nth-dimension.org.uk>
# <http://www.nth-dimension.org.uk/> / <http://www.machine.org.uk/>

use strict;
use Fuzzled::Protocol::HTTP;

my $hostname;
my $portnumber;
my $maximumprocess;
my $debugflag;
my $httphandle;

if (@ARGV != 4) {
	die "usage: " . $0 . " <hostname> <portnumber> <maximumprocess> <debugflag>";
}
$hostname = shift;
$portnumber = shift;
$maximumprocess = shift;
$debugflag = shift;
if ($hostname =~ /([A-z0-9-.]+)/) {
	$hostname = $1;
} else {
	die "usage: " . $0 . " <hostname> <portnumber> <maximumprocess> <debugflag>";
}
if ($portnumber =~ /([0-9]+)/) {
	$portnumber = $1;
} else {
	die "usage: " . $0 . " <hostname> <portnumber> <maximumprocess> <debugflag>";
}
if ($maximumprocess =~ /([0-9]+)/) {
	$maximumprocess = $1;
} else {
	die "usage: " . $0 . " <hostname> <portnumber> <maximumprocess> <debugflag>";
}
if ($debugflag =~ /([01])/) {
	$debugflag = $1;
} else {
	die "usage: " . $0 . " <hostname> <portnumber> <maximumprocess> <debugflag>";
}
$httphandle = Fuzzled::Protocol::HTTP->new($hostname, $portnumber, $maximumprocess, $debugflag);
$httphandle->attack();
exit(1);