#!/usr/bin/perl -T -w
# $Header: /var/lib/cvsd/var/lib/cvsd/Fuzzled/src/Drivers/parsepacket.pl,v 1.1.1.1 2007-02-14 12:20:29 timb Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# (c) Tim Brown, 2006
# <mailto:timb@nth-dimension.org.uk>
# <http://www.nth-dimension.org.uk/> / <http://www.machine.org.uk/>

use strict;
use Fuzzled::Helper;
use Fuzzled::Factory::BruteForce;
use Fuzzled::Namespace::Separate;
use Fuzzled::PacketParse::Separate;

my $filename;
my $modeflag;
my $startposition;
my $debugflag;
my $packethandle;
my $readbuffer;
my $readdata;
my $helperhandle;
my $separatorhandle;
my $separatorstring;

if (@ARGV != 4) {
	die "usage: " . $0 . " <filename> <modeflag> <startposition> <debugflag>\n\tmodeflag: 0 - separated, 1 - run length encoded";
}
$filename = shift;
$modeflag = shift;
$startposition = shift;
$debugflag = shift;
if (! -e $filename) {
	die "usage: " . $0 . " <filename> <modeflag> <startposition> <debugflag>\n\tmodeflag: 0 - separated, 1 - run length encoded";
}
if ($modeflag =~ /([01])/) {
	$modeflag = $1;
} else {
	die "usage: " . $0 . " <filename> <modeflag> <startposition> <debugflag>\n\tmodeflag: 0 - separated, 1 - run length encoded";
}
if ($startposition =~ /([0-9]+)/) {
	$startposition = $1;
} else {
	die "usage: " . $0 . " <filename> <modeflag> <startposition> <debugflag>\n\tmodeflag: 0 - separated, 1 - run length encoded";
}
if ($debugflag =~ /([01])/) {
	$debugflag = $1;
} else {
	die "usage: " . $0 . " <filename> <modeflag> <startposition> <debugflag>\n\tmodeflag: 0 - separated, 1 - run length encoded";
}
print "[fuzzled] parsing packet from " . $filename . "\r\n";
open($packethandle, "<" . $filename);
$readdata = "";
while (sysread($packethandle, $readbuffer, 1)) {
	if ($readbuffer eq "") {
		last;
	}
	$readdata = $readdata . $readbuffer;
}
$helperhandle = Fuzzled::Helper->new($debugflag);
if ($modeflag == 0) {
	$separatorhandle = Fuzzled::Factory::BruteForce->new(Fuzzled::Namespace::Separate->generate());
	while ($separatorstring = $separatorhandle->generate()) {
		printf("[fuzzled] using %02x\r\n", ord($separatorstring));
		print "[fuzzled] " . Fuzzled::PacketParse::Separate->parse($readdata, $startposition, $separatorstring);
	}
} else {
}
exit(1);