# $Header: /var/lib/cvsd/var/lib/cvsd/Fuzzled/src/Fuzzled-PacketParse-Separate/lib/Fuzzled/PacketParse/Separate.pm,v 1.1.1.1 2007-02-14 12:20:32 timb Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# (c) Tim Brown, 2006
# <mailto:timb@nth-dimension.org.uk>
# <http://www.nth-dimension.org.uk/> / <http://www.machine.org.uk/>

package Fuzzled::PacketParse::Separate;

use 5.008007;
use strict;
use warnings;

require Exporter;
use AutoLoader qw(AUTOLOAD);

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration use Fuzzled::PacketParse::Separate ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);

our $VERSION = ('$Header: /var/lib/cvsd/var/lib/cvsd/Fuzzled/src/Fuzzled-PacketParse-Separate/lib/Fuzzled/PacketParse/Separate.pm,v 1.1.1.1 2007-02-14 12:20:32 timb Exp $' =~ m/.Header: .* ([\d.]+) .*/)[0];

# Preloaded methods go here.
sub parse {
	my $self;
	my $readdata;
	my $startposition;
	my $paddingbyte;
	my $paddingcounter;
	my $packetdata;
	my $stringdata;
	my $currentoffset;
	my $datacounter;
	my $readbuffer;
	$self = shift;
	$readdata = shift;
	$startposition = shift;
	$paddingbyte = shift;
	$packetdata = "";
	$stringdata = "";
	$paddingcounter = 0;
	$currentoffset = 0;
	$datacounter = 0;
	$readdata = substr($readdata, $startposition);
	foreach $readbuffer (split("", $readdata)) {
		if ($readbuffer eq $paddingbyte) {
			$packetdata = $packetdata . sprintf("%02x ", ord($readbuffer));
			$stringdata = $stringdata . ".";
			$paddingcounter ++;
		} else {
			if ($paddingcounter > 0) {
				$packetdata = $packetdata . sprintf("\t%s\r\n", $stringdata);
				$packetdata = $packetdata . sprintf("0x%08x: data block: 0x%02x bytes (0x%02x padding bytes)\r\n", $currentoffset, $datacounter, $paddingcounter);
				$stringdata = "";
				$paddingcounter = 0;
				$currentoffset = $currentoffset + $datacounter;
				$datacounter = 0;
			}
			if ((ord($readbuffer) < 32) || (ord($readbuffer) > 126)) {
				$stringdata = $stringdata . ".";
			} else {
				$stringdata = $stringdata . $readbuffer;
			}
			$packetdata = $packetdata . sprintf("%02x ", ord($readbuffer));	
		}
		$datacounter ++;
	}
	if ($stringdata ne "") {
		$packetdata = $packetdata . sprintf("\t%s\r\n", $stringdata);
		$packetdata = $packetdata . sprintf("0x%08x: data block: 0x%02x bytes (0x%02x padding bytes)\r\n", $currentoffset, $datacounter, $paddingcounter);
	}
	return $packetdata;
}

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__

# Below is stub documentation for your module. You'd better edit it!

=head1 NAME

Fuzzled::PacketParse::Separate - Perl extension for Fuzzled to parse packets

=head1 SYNOPSIS

  use Fuzzled::PacketParse::Separate;

  my $separatetesthandle;

  $separatetesthandle->parse("hello\x0a\x0d\x001234567890\x0a\x0d\x00\x00\x00\x00", 0, "\x00")

=head1 DESCRIPTION

C<Fuzzled::PacketParse::Separate> is a Perl extension for Fuzzled to parse packets.  The following methods are available:

=over 4

=item Fuzzled::PacketParse::Separate->parse(<readdata>, <startposition>, <paddingbyte>)

Parses the specified packet.

Returns the parsed data.

=head1 SEE ALSO

=head1 AUTHOR

(c) Tim Brown, 2006
<mailto:timb@nth-dimension.org.uk>

=head1 COPYRIGHT AND LICENSE

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

=cut